#include  <htc.h>
/***** RtBM[V̐ݒ *********/
__CONFIG(FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF 
		& CPD_OFF & BOREN_OFF & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF);
__CONFIG(WRT_OFF & PLLEN_OFF & STVREN_OFF & BORV_LO & LVP_OFF);

extern const unsigned char pattern[];
unsigned char selectbit,shiftreg;
unsigned char color[20];
unsigned char decimal;
volatile unsigned char count,count1,count1L;
volatile unsigned char bwsign,bwsign1,bwcount;
volatile unsigned char roundflag;
volatile unsigned int roundcounter;

void interrupt T0ISR(void){
//	TMR0 = 150;				// ^C}0Đݒ 20KHz
	TMR0 = 200;				// ^C}0Đݒ 40KHz

#asm
	movf _PORTC,w
	andlw 0x10
	movwf _bwsign1
	incf _roundcounter,f
	btfsc status,2
	incf _roundcounter+1,f
#endasm
//	bwsign1=PORTC & 0x10;
//	roundcounter++;

	if(bwsign!=bwsign1){
		bwcount++;
		if(bwcount>=10){
			bwsign=bwsign1;
			bwcount=0;
			if(bwsign==0){
				roundflag=1;
				count1=roundcounter>>7;
				count1L=(unsigned char)roundcounter<<1;
				roundcounter=0;
			}
		}
	}
	else bwcount=0;

	LATA=0;
	LATB=0;
	LATC=0xe0;

	if(selectbit<8) LATA=shiftreg;
	else if(selectbit<16) LATB=shiftreg;
	else LATC|=shiftreg;
	LATC&=~color[selectbit];
#asm
	movlb 0
	lslf _shiftreg,f
	btfsc status,2
	incf _shiftreg,f
	incf _selectbit,w
	movwf _selectbit
	sublw 20
	btfss status,2
	goto label2
	clrf _selectbit
	clrf _shiftreg
	incf _shiftreg,f
label2:
	incf _count,f
#endasm
//	shiftreg*=2;;
//	if(shiftreg==0) shiftreg=1;
//	selectbit++;
//	if(selectbit==20){
//		selectbit=0;
//		shiftreg=1;
//	}
//	count++;

	TMR0IF = 0;
}
void main()
{
	unsigned char i;
	unsigned char *colorp;
	const unsigned char *patternp;

	OSCCON = 0xf0;			// 8MHz INTOSC with 4xPLL
	/* I/Oݒ */
	TRISA = 0;
	TRISB = 0;
	TRISC = 0x10; //RC4:
	OPTION_REG=0x01; //vXP[1:4
	TMR0 = 1;				// ^C}0ݒ
	selectbit=0;
	shiftreg=1;
	LATA=0;
	LATB=0;
	LATC=0;
	count=0;
	PEIE = 1;				// Ӌ
	GIE = 1;					// O[o
	TMR0IE=1;

	roundflag=0;
	roundcounter=0;
	bwsign=0;
	bwcount=0;
	count1=50;
	count1L=0x70;
	decimal=0;

/*
	color[0]=0xbf;
	i=0;
	while(1){
		if(roundflag){
			color[i]=0;
			i++;
			if(i>=20) i=0;
			color[i]=0xbf;
			roundflag=0;
		}
	}
*/
	patternp=pattern;
i=0;
colorp=color;
	while(1){

		if(roundflag){
			patternp=pattern;
			roundflag=0;
		}

		if(count>count1){
			count=1;

#asm
			movf _count1L,w
			addwf _decimal,f
			btfsc status,0
			decf _count,f
#endasm

//			colorp=color;
//			for(i=0;i<20;i++) *colorp++=*patternp++;
#asm
			movf main@patternp,W
			movwf fsr0l
			movf main@patternp+1,W
			movwf fsr0h
;			movf main@colorp,W
			movlw _color
			movwf fsr1l
			clrf fsr1h
			movlw 20
			movwf main@i
label1:
			moviw fsr0++
			movwi fsr1++
			decfsz main@i,f
			goto label1
#endasm

			patternp+=20;
			if(patternp>=pattern+20*128) patternp=pattern;
		}
	}
}
